page 58,132
title	DBLLOCK.ASM
subttl	Lock DoubleSpace CVF files

COMMENT * Protect Dos6 DBLSPACE host drive from accidental deleting the CVF.
          SHARE must be loaded before use.

Version 1.0, June 1993
*

CSEG	SEGMENT	PARA PUBLIC 'CODE'
ASSUME	CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG

PSPEnvr         EQU     2Ch
DTA             EQU     80h

		ORG	100h
Start:
MAIN		PROC	NEAR
		MOV	DX,OFFSET CPRight	;show copyright message
		MOV	AH,9
		INT	21h
		CALL    IsDblspc                ;check if Dblspace is loaded
		JZ      ChkShare
		MOV     DX,OFFSET WarnMsg       ;If not, show warning message
		MOV     AH,9
		INT     21h
ChkShare:       CALL    IsShare                 ;check if SHARE is loaded
		JC      Error
		CALL    GetDrvNum               ;get drive number to protect from command line
                JC      Error
                CALL    LockCVF                 ;Lock Dblspace CVF
                JC      Error

		MOV	DX,OFFSET NoErrmsg	;Show no-error message and quit
		MOV	AH,9
		INT	21h
		MOV     ES,WORD PTR CS:[PSPEnvr]
		MOV     AH,49h                  ;Release environment
		INT     21h
                MOV     DX,0                    ;keep program in memory
                MOV     AX,3100h                ;terminate and stay resident
                INT     21h

Error:          PUSH    AX                      ;Save Error code
                MOV	DX,OFFSET Errmsg	;Show error message and quit
		MOV	AH,9
		INT	21h
                POP     AX                      ;Restore Error code
                CMP     AL,1
                JNZ     Emsg2
                MOV     DX,OFFSET Msg1
                JMP     Quit
Emsg2:          MOV     DX,OFFSET Msg2
                CMP     AL,2
                JZ      Quit
                MOV     DX,OFFSET Msg3

Quit:           MOV     AH,9                    ;Show message
                INT     21h
		MOV	AH,04Ch 		;Return to DOS
		INT	21h

HostDrive       DB      ?                       ;host drive number to write protect
                DB      ':\'
FilName         DB      'DBLSPACE.???',0        ;CVF FileName

COMMENT * Copyright notice *
CPRight		DB	'DBLLOCK.COM V.1.0',0Dh,0Ah
                DB      '(C) Copyright 1993 Promcan-Agma',0Dh,0Ah,'$'
                DB      '96 rue Kipps, Greenfield Park, Qubec',0Dh,0Ah
                DB      'Tel.: (514) 923-0934',0Dh,0Ah,'$'

WarnMsg         DB      'DBLSPACE not loaded yet !',0Dh,0Ah,'$'

NoErrmsg	DB	'DBLLOCK installed for host drive.',0Dh,0Ah,'$'

Errmsg		DB	'DBLLOCK not installed !',0Dh,0Ah,'$'

Msg1            DB      'SHARE not installed.',0Dh,0Ah
                DB      'You must load SHARE before running DBLLOCK.',0Dh,0Ah,'$'

Msg2		DB	'Invalid parameter or drive not valid.',0Dh,0Ah
		DB	'SYNTAX is : DBLLOCK Drive',0Dh,0Ah,'$'

Msg3            DB      'DblSpace CVF not found or already locked on this drive.',0Dh,0Ah
                DB      'Retry with another drive name.',0Dh,0Ah,'$'

MAIN		ENDP
;***************************************************************************************
;IsDblspc       Check if DBLSPACE is loaded
IsDblspc        PROC    NEAR
                MOV     AX,4A11h
                MOV     BX,0
                INT     2Fh
                CMP     AX,0
                RET
IsDblspc        ENDP
;***************************************************************************************
;IsShare        Check is SHARE is loaded
IsShare         PROC    NEAR
                MOV     AX,1000h
                INT     2Fh
                CMP     AL,0FFh                 ;is share loaded ?
                JNZ     NoShare
                CLC                             ;yes, clear carry flag
                RET                             ;and return
NoShare:        STC                             ;else, set carry flag
                MOV     AX,1                    ;set error code 1
                RET                             ;and return
IsShare         ENDP
;***************************************************************************************
;GetDrvNum      Get Drive Number from passed parameter
GetDrvNum       PROC    NEAR
                MOV     SI,80h                  ;point SI to parameter area
GetDrvLoop:     INC     SI
                MOV     AL,[SI]                 ;get character
                CMP     AL,20h                  ;if space, get next
                JZ      GetDrvLoop
                CMP     AL,'/'                  ;if backslash, get next
                JZ      GetDrvLoop
                CMP     AL,'-'                  ;if minus, get next
                JZ      GetDrvLoop
                CMP     AL,0                    ;is null, exit with error
                JZ      GetDrvErr
                AND     AL,5Fh                  ;convert to lowercase
                MOV     CS:[HostDrive],AL       ;save it
                CLC                             ;reset error flag
                RET                             ;return

GetDrvErr:      MOV     AX,2                    ;return with error code 2
                STC                             ;and carry flag
                RET
GetDrvNum       ENDP
;***************************************************************************************
;LockCVF        Find, Open in lock mode DblSpace CVF files
LockCVF         PROC    NEAR
                MOV     AX,4E00h                ;Find first CVF file
                MOV     CX,7
                MOV     DX,OFFSET HostDrive
                INT     21h
                JC      LockErr                 ;if not found, return with error

LockLoop:       MOV     SI,OFFSET DTA+1Eh       ;transfer filename
                MOV     DI,OFFSET FilName
                MOV     CX,12                   ;Len of Filename
                REP     MOVSB

                CALL    OpenFile                ;and lock file
                JC      LockErr
                ;save handle

                MOV     AX,4F00h                ;Find next CVF file
                INT     21h                     ;and lock it
                JNC     LockLoop                ;until no more CVF found
                CLC                             ;clear error flag
                RET                             ;and return

LockErr:        MOV     AX,3                    ;Return with Error code and carry
                STC
                RET

OpenFile:       MOV     AH,3Dh                  ;open file in locked mode
                MOV     AL,10h                  ;access code
                MOV     DX,OFFSET [HostDrive]   ;point to CVF True Filename
                INT     21h
                RET
LockCVF         ENDP
;***************************************************************************************
CSEG		ENDS
END		Start

