





                    INSTALLING A COLORADO MAG TAPE



OVERVIEW

This document will tell you all you need to know to install any of the
Colorado line of mag tapes.  The Colorado manuals have helpful
illustrations, but they presume you know more about computers than you
probably do.  You should use this document as an adjunct to the
Colorado installation manuals.


THE CHOICES

The Colorado line of mag tape backups is complex.  There are four
basic models of drive:  the low end Jumbo 120 (also known as the DJ-
10), the midrange Jumbo 250 (also known as the DJ-20), the high end
QFA-500, and the top of the line QFA-700.  The QFA-500 is now
discontinued.  Each comes in both internal and external versions.

There are 6 different controllers: the AB-10, AB-11, FC-10, TC-15, PC-
02 and TC-02.  The PC-02 is now discontinued.  Each can work with some
subset of the drives.  Only some of these combinations make economic
sense.  There is no point in matching a low performance controller
with a high performance drive (or vice versa) even if it is possible.
In addition, the DJ-10 and DJ-20 can operate without any controller at
all (if you have no B: floppy) or with a special cable called a CK-17
if you do have a B: floppy.  The CK-17 is just an ordinary floppy
cable with two B: floppy connectors -- one for the tape and one for
the B: floppy.

Here is a table to help you figure this all out.  All speeds shown are
in Megabytes per minute.  These are the fastest possible speeds,
presuming your computer is a 386 that can keep up with the drive.
Compression is presumed.  Starred configurations are the most common
and cost-effective.

                                Drive

Controller DJ-10    DJ-20   QFA-500   QFA-700     Notes

none        *2.2      2.2         -         -     uses floppy ctrlr
CK-17       *2.2      2.2         -         -     uses floppy ctrlr
AB-10       *2.2      2.2         -         -     uses floppy ctrlr
AB-11       *2.2      2.2         -         -     uses floppy ctrlr
FC-10        2.2     *4.4         -         -     software compress
TC-15        4.4     *8.8         -         -     hardware compress
PC-02          -        -      *3.3         -     software compress
TC-02          -        -     *7.25       *12     hardware compress






 %AB%\backup\magtape.doc  -1-  last updated by Roedy Green
                         1993/06/20





                    Installing a Colorado Mag Tape


INSTALLING THE TAPE DRIVE

Each of the four kinds of Colorado Mag tape can be installed either
internally or externally.  In either case, take the drive completely
apart, and clean all the electrical connections with Cramolin, rinse
with isopropanol and treat them with Stabilant.  See Repair.Doc for
more detailed instructions on Cramolin/Stabilant use.  Don't use
Cramolin on contacts you cannot thoroughly rinse; just use Stabilant
on them.

Don't put Cramolin or Stabilant on the read/write head.  Clean these
mechanical parts with simple isopropanol.

After you mount the tape drive either in the computer, or inside an
external box, make sure you have connected:

  1. Power

  2. Grounding strap

  3. Data ribbon cable to edge connector.  Pin 1 of the edge
     connector is near the notch.  Pin 1 of the ribbon cable is
     the one marked with the stripe.

  4. In the external case there is also a power connector for the
     fan.  BE SURE YOU GET IT ON THE RIGHT WAY ROUND!  The wires
     come out the top.


TAPE DRIVE JUMPERS

Colorado has gradually been simplifying the jumpers on its drives.  If
the jumpers I describe are not present, don't worry about them.

  1. Older drives have a DS0-DS1 jumper for address selection.
     Set the jumper on the lower DS0 setting.

  2. The terminating resistors can be left on the upper
     UNterminated setting ONLY if the drive is being used
     internally without any controller!  For ALL other uses, they
     *MUST* be moved to the lower TERMINATED setting.  Without a
     controller, the tape drive is mounted in the middle of the
     floppy cable.  In all other cases the tape drive is mounted
     at the END (terminus hence terminated) of its own private
     cable.  This applies to both internal and external mounting.


TAPE DRIVE CONTROLLER INSTALLATION

Clean the electrical contacts of the controller with Cramolin,
isopropanol and Stabilant in the usual way.  Most of the controllers
have no jumpers at all.  Some of the AB-10 controllers have a single




 %AB%\backup\magtape.doc  -2-  last updated by Roedy Green
                         1993/06/20





                    Installing a Colorado Mag Tape


jumper.  Set the jumper across the upper pair of pins (this should be
the factory default setting) to select the ALTERNATE position.  Note
the weird ALTERANATE is the USUAL setting.


CABLES BETWEEN THE CONTROLLER AND THE TAPE

The higher end FC-10, TC-15, PC-02 and TC-02 controllers are simpler,
so I will start with them.

First hook up the 12V 4-prong power supply lead to the controller.

Then attach a cable from the controller to the tape drive.  If the
tape is mounted externally, a round cable will run from the back of
your computer to the tape.  If it is mounted internally, a 34-
conductor ribbon cable will run from the controller to the tape drive.

See my essay on how to make your own high-quality cables.  It is best
to make your own ribbon cables so they are the exact length needed and
they are made with the highest quality connectors.


ATTACHING THE AB-10 CONTROLLER

First hook up the 12V 4-prong power supply lead to the controller.

If you have the cheap AB-10 controller, connect the cable to the tape
in the same way as for the high end controllers, making sure you hook
your cable up to the connector marked TAPE.  However you also need TWO
MORE connectors to your AB-10 controller.  Your AB-10 INTERCEPTS the
cable going from the floppy drive controller on its way to the
floppies.  So you need a short cable from the floppy drive controller
to the AB-10 and another long cable from the AB-10 out to the
floppies.  There are THREE ribbon cables sprouting from the AB-10.
That is PLENTY of opportunity to screw up.  You must get each cable on
the right connector with pin 1 on the right pin.

If you use prefabricated cables, installation will be a mess because
there is the possibility of edge or pin connectors on your floppy
drive controller and ditto for your floppies.  The prefab cable has to
be too long with too many connectors just to cover all possibilities.
You are much better off making your own custom length cables with just
the needed connectors.


ATTACHING THE AB-11 CONTROLLER

This controller is a miniature, simplified version of the AB-10.  It
does not necessarily even use a slot.  It simply intercepts the floppy
cable on its way from the floppy controller to the floppy drives, to
present those signals to a connector out the back for the external
tape to hook to.




 %AB%\backup\magtape.doc  -3-  last updated by Roedy Green
                         1993/06/20





                    Installing a Colorado Mag Tape


First hook up the 12V 4-prong power supply lead to the controller.

You can use the prefab cables Colorado provides, but you can do it
more cleanly, by simply adding a 3rd 34-pin connector to the floppy
cable and allowing that to connect to the AB-11.


CONTROLLERLESS OPERATION

In tight budget situations, you can run with no controller at all.
You just attach the tape drive as if it were an extra floppy drive.
It can either plug in where the B: floppy would normally plug in, or
on a third UNTWISTED connector between the floppy drive controller and
the B: floppy.

You can buy a prefabricated CK-17 cable that is much too long with too
many connectors, or you can make your own custom cable.


NOTES ON MAKING YOUR OWN CABLES

I wrote a whole essay on making your own ribon cables in CABLE.DOC,
but let me emphasize a few points.  You have to get pin 1 to the red
conductor (or brown in rainbow cables).  Each connector you add could
be edge or pin and could point up or down.  If you plan carefully, you
can arrange for your cable to have minimal twists.  With three cables
sprouting from the AB-10 it gets pretty tight for space.  You don't
want any needless twists or excess cable length.


INSTALLING THE SOFTWARE

Reboot to a clean system with nothing confusing:  No Windows, No
DESQview, no QEMM, no Cache -- Raw as you can get.  Life is confusing
enough without added complications.

A:

INSTALL

Follow your nose.  It will ask you the usual questions -- what drive
to install on, do you have a colour monitor etc.

It will ask you what kind of controller you have.  Unfortunately it
does not call the controllers by their usual names:

AB-10 = Floppy tape adapter

AB-11 = Floppy tape adapter

FC-10 = Jumperless tape controller





 %AB%\backup\magtape.doc  -4-  last updated by Roedy Green
                         1993/06/20





                    Installing a Colorado Mag Tape


TC-15 = Jumperless tape controller with compression

PC-02 = Jumperless tape controller (discontinued)

TC-15 = Jumperless tape controller with compression

When you get to hardware install, select MANUAL.  It will allow you to
override its choice of IO port address, DMA channel and IRQ.  I have
found its default choices often do not work, particularly the DMA
channel.  What will work?  Well it depends on what other devices you
have.  You can ask experts for help, or just muddle through trying
combinations till you find one that works.


FINE TUNING

Run the TAPE.EXE program and select UTILITIES then SOFTWARE SETUPS.
Set up your options like this:

AUTO TAPE/DISK DATA COMPARISON AFTER BACKUP                Y

OVERWRITE EXISTING FILES DURING RESTORE:                   Y

READ ONLY MODE ON BACKUPS:                                 N

CONCURRENT DISK/TAPE OPERATION:                            Y

SOFTWARE DATA COMPRESSION TYPE:                OPTIMIZE TIME

FILE SORT TYPE:                                    EXTENSION

MULTI-VOLUME BACKUP:                                       Y

Never versions of the software have a different menu layout, more GUI-
looking, but the information is the same.

Then format a tape and do a firedrill.  Back up a directory to tape,
make a copy elsewhere, erase the original disk copy, and see if you
can restore it from tape.

When running the tape.exe program from menus, be careful not to type
when the tape is moving.  If you do, you will get ahead of the
program, and then eventually your stored up keystrokes will be
accepted and will have unexpected effects.


TROUBLE SHOOTING

When the tape does not work, here are the things you have most likely
done wrong:

  1. You forgot to set the terminating resistors ON.




 %AB%\backup\magtape.doc  -5-  last updated by Roedy Green
                         1993/06/20





                    Installing a Colorado Mag Tape


  2. You hooked up the three AB-10 cables in some hare-brained
     way.

  3. You twisted a cable so that pin 1 is on the wrong end.

  4. You forgot to hook up the power to the tape or the
     controller.

  5. You chose an IO port, DMA channel or IRQ already in use.
     DMA channel 2 is the floppy controller.  DMA channel 3 is
     usually safe.  I find port 370 is usually free.  IRQ 6 is
     the floppy controller.  In most machines IRQ 2 (really IRQ
     9) is free.

  6. You have a "cranky" machine.  Try setting CONCURRENT
     DISK/TAPE OPERATION to NO.

  7. Other programs running simultaneously are interfering with
     the tape. Set up a TAPE.BAT file to reboot to a clean
     environment for tape operations.  See VARAUTO.DOC no how to
     do this.  I have also written BKTAPE.BAT to totally automate
     the backup.  It is controlled by C.TAG D.TAG files in the
     C:\ENV directory which tell it which files to backup.  WATCH
     OUT!  Colorado does not backup hidden files EVER!  If you
     want them backed up, you have to unhide them first.  The
     configuration SET commands needed to make it run are in
     C:\ENV\SETS.BAT.  The ones most germane to tapes are:
     SET TAPE=C  -- where software is installed.
     SET CUSTOMER=The ABC Company  -- label for tape.


PARTING WORDS

You may have noticed that the cheaper the controller the more
elaborate the installation.  The high end ones just have you stick in
a controller and hook up one cable.  Further, the low end controllers
use the floppy controller.  If the floppy controller is crummy, you
will have no end of trouble.  I strongly recommend using at least an
FC-10 controller if you want a simple, trouble-free install.  The TC-
15 with hardware compression is not necessarily a good idea.  If your
CPU is fast enough, it can do the compression in software fast enough
anyway.  The TC-15 controller sometimes has trouble in machines with
non-standard bus speeds.  The cheaper AB-10/11 controllers and
controllerless operation installs are best left to experienced
technicians.

-30-









 %AB%\backup\magtape.doc  -6-  last updated by Roedy Green
                         1993/06/20


