//  Author:  Keith A. Confer	Date:  April 25, 1993
//  This program determines the space DOS is allocating for
//  each file on the default drive.  The program then determines
//  the space gained by reformatting the hard drive to
//  utilize smaller clusters.

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <direct.h>
#include <stdlib.h>

//*****************************************************************************
//  Declaring structure for holding drive data                              //*
union REGS inregs, outregs;                                                 //*
                                                                            //*
struct diskdata                                                             //*
	{                                                                       //*
	unsigned int sectors_per_cluster;                                       //*
	unsigned int bytes_per_sector;                                          //*
	unsigned int bytes_per_cluster;                                         //*
	} disk;                                                                 //*
//  End of Structure Delclaration                                           //*
//*****************************************************************************


//*****************************************************************************
//  Function declarations                                                   //*
int GetClusterSize(char drive);                                             //*
void FindFiles();                                                           //*                                                   
//  End of Function Declarations                                            //*
//*****************************************************************************



//*****************************************************************************
//  Variable Declarations                                                   //*
int drive;                                                                  //*
int curdrive;                                                               //*
long int bytes_per_cluster;                                                 //*
long int next_bytes_per_cluster;                                            //*
char buffer[_MAX_DIR];                                                      //*
long int total_bytes_used_by_files = 0;                                     //*
long int total_bytes_allocated_by_dos = 0;                                  //*
long int total_next_bytes_allocated_by_dos = 0;                             //*
long int number_files = 0;                                                  //*
int bGlobalSearch = 1;                                                      //*
//  End of Variable Declarations                                            //*
//*****************************************************************************


//*****************************************************************************
//  Beginning of main                                                       //*
void main( int argc,        /* Number of strings in array argv          */  //*
           char *argv[],    /* Array of command-line argument strings   */  //*
           char **envp )    /* Array of environment variable strings    */  //*
{                                                                           //*
    /*int count;*/                                                          //*
                                                                            //*
    /* Display each command-line argument. */                               //*
    /*printf( "\nCommand-line arguments:\n" );                              //*
    for( count = 0; count < argc; count++ )                                 //*
        printf( "  argv[%d]   %s\n", count, argv[count] ); */               //*
                                                                            //*
    puts("Enter drive to be checked:");                                     //*
    drive=toupper(getchar());                                               //*
    GetClusterSize(drive);                                                  //*
    curdrive = _getdrive();                                                 //*
    _getcwd(buffer, _MAX_DIR);                                              //*
    _chdrive(drive - 64);                                                   //*
    _chdir("\\");                                                           //*
    FindFiles();                                                            //*
    _chdrive(curdrive);                                                     //*
    _chdir(buffer);                                                         //*
                                                                            //*
    return;                                                                 //*
}                                                                           //*
//  End of main                                                             //*
//*****************************************************************************                                                                           




//*****************************************************************************
//  Function FindFiles                                                      //*
void FindFiles()                                                            //*
{                                                                           //*
struct find_t all_files;                                                    //*
long int clusters;                                                          //*
long int dos_bytes_allocated;                                               //*
long int remainder;                                                         //*
long int next_clusters;                                                     //*
long int next_remainder;                                                    //*
long int next_dos_bytes_allocated;                                          //*              
long int bytes_saved;                                                       //*
                                                                            //*
                                                                            //*
	_dos_findfirst("*.*", _A_NORMAL | _A_SUBDIR | _A_RDONLY |_A_HIDDEN |    //*
					 _A_SYSTEM | _A_ARCH | _A_VOLID, &all_files);           //*
		clusters = all_files.size/disk.bytes_per_cluster;                   //*
		next_clusters = all_files.size/next_bytes_per_cluster;              //*
		remainder = all_files.size % disk.bytes_per_cluster;                //*
		next_remainder = all_files.size % next_bytes_per_cluster;           //*
			if(remainder) clusters++;                                       //*
			if(next_remainder) next_clusters++;                             //*
		dos_bytes_allocated = (clusters * disk.bytes_per_cluster);          //*
		next_dos_bytes_allocated = (next_clusters * next_bytes_per_cluster);//*
		printf("Listing of all files\n\n");                                 //*
		printf("%-12s is %-7li bytes.  DOS is allocating %-7li bytes for this file.\n", all_files.name, all_files.size, dos_bytes_allocated);
		total_bytes_allocated_by_dos = total_bytes_allocated_by_dos +       //*
										dos_bytes_allocated;                //*
		total_next_bytes_allocated_by_dos = total_next_bytes_allocated_by_dos + next_dos_bytes_allocated;
		total_bytes_used_by_files = total_bytes_used_by_files +             //*
										all_files.size;                     //*
		number_files++;                                                     //*
	                                                                        //*
	while(_dos_findnext(&all_files)==0)                                     //*
		{                                                                   //*
		clusters = all_files.size/disk.bytes_per_cluster;                   //*
		next_clusters = all_files.size/next_bytes_per_cluster;              //*
		remainder = all_files.size % disk.bytes_per_cluster;                //*
		next_remainder = all_files.size % next_bytes_per_cluster;           //*
		if(remainder) clusters++;                                           //*
		if(next_remainder) next_clusters++;                                 //*
		dos_bytes_allocated = (clusters * disk.bytes_per_cluster);          //*
		next_dos_bytes_allocated = (next_clusters * next_bytes_per_cluster);//* 
		printf("%-12s is %-7li bytes.  DOS is allocating %-7li bytes for this file.\n",all_files.name, all_files.size, dos_bytes_allocated); 
		total_bytes_allocated_by_dos = total_bytes_allocated_by_dos +       //*
										dos_bytes_allocated;                //*
	    total_next_bytes_allocated_by_dos = total_next_bytes_allocated_by_dos + next_dos_bytes_allocated;
		total_bytes_used_by_files = total_bytes_used_by_files +             //*
										all_files.size;                     //*
		number_files++;                                                     //*
	    }                                                                   //*
	printf("\nThere are a total of %li files on this drive.\n",             //*
						number_files);                                      //*
	printf("Total bytes used by files: %li\n",total_bytes_used_by_files);   //*
	printf("Total bytes DOS is allocating for these files is: %li\n",       //*
						total_bytes_allocated_by_dos);                      //*
	printf("DOS would allocate %li bytes if you were to reformat your\ndrive to use %li byte clusters.\n", total_next_bytes_allocated_by_dos, next_bytes_per_cluster);
	bytes_saved = total_bytes_allocated_by_dos - total_next_bytes_allocated_by_dos;
	printf("\nYou would gain %li bytes by reformatting to use %li byte clusters.\n", bytes_saved, next_bytes_per_cluster); 
                                                                            //*
if (bGlobalSearch)                                                          //*
{                                                                           //*
if (_dos_findfirst("*.", _A_SUBDIR, &all_files)==0) {                       //*
         if ((strcmp(all_files.name, ".") !=0)                              //*
            && (strcmp(all_files.name, "..") !=0)                           //*
            && (all_files.attrib & _A_SUBDIR))                              //*
         {                                                                  //*
            chdir( all_files.name );                                        //*
            FindFiles();                                                    //*
            chdir( "..");                                                   //*
         }                                                                  //*
         while (_dos_findnext(&all_files)==0)                               //*
         {                                                                  //*
            if ((strcmp(all_files.name, ".") !=0)                           //*
               && (strcmp(all_files.name, "..") !=0)                        //*
               && (all_files.attrib & _A_SUBDIR))                           //*
            {                                                               //*
               chdir( all_files.name );                                     //*
               FindFiles();                                                 //*
               chdir( ".." );                                               //*
            }                                                               //*
         }                                                                  //*
      } /* if found first */                                                //*
}                                                                           //*                                                                           //*
return;                                                                     //*
}                                                                           //*
//  End of Function FindFiles                                               //*
//*****************************************************************************


//*****************************************************************************
//  Function GetClusterSize used to determine the cluster size on the       //*
//  default drive.                                                          //*
int GetClusterSize(drive)                                                   //*
{                                                                           //*
inregs.x.dx = drive - 64;                                                   //*
inregs.x.ax=0x3600;                                                         //*
                                                                            //*
int86(0x21, &inregs, &outregs);                                             //*
                                                                            //*
disk.sectors_per_cluster=outregs.x.ax;                                      //*
disk.bytes_per_sector=outregs.x.cx;                                         //*
                                                                            //*
disk.bytes_per_cluster=outregs.x.cx * outregs.x.ax;                         //*
if((disk.bytes_per_cluster)== 256)                                          //*
	{                                                                       //*
	next_bytes_per_cluster = 128;                                           //*
	}                                                                       //*
if((disk.bytes_per_cluster)== 512)                                          //*
	{                                                                       //*
	next_bytes_per_cluster = 256;                                           //*
	}                                                                       //*
if((disk.bytes_per_cluster)== 1024)                                         //*
	{                                                                       //*
	next_bytes_per_cluster = 512;                                           //*
	}                                                                       //*
if((disk.bytes_per_cluster)== 2048)                                         //*
	{                                                                       //*
	next_bytes_per_cluster = 1024;                                          //*
	}                                                                       //*
if((disk.bytes_per_cluster)== 4096)                                         //*
	{                                                                       //*
	next_bytes_per_cluster = 2048;                                          //*
	}                                                                       //*
if((disk.bytes_per_cluster)== 8192)                                         //*
	{                                                                       //*
	next_bytes_per_cluster = 4096;                                          //*
	}                                                                       //*
if ((disk.bytes_per_cluster) == 16384)                                      //*
	{                                                                       //*
	next_bytes_per_cluster = 8192;                                          //*
	}                                                                       //*
if ((disk.bytes_per_cluster) == 32768)                                      //*
	{                                                                       //*
	next_bytes_per_cluster = 16384;                                         //*
	}                         //*                                           //*
return (disk.bytes_per_cluster, next_bytes_per_cluster);                    //*
}                                                                           //*
//  End of function GetClusterSize                                          //*
//*****************************************************************************








